-- Restores v1 spring panels, with new physics accounted for
-- No remapping for custom terrain since that damn thing aint exposed, sooo

-- Will put a proper versioning system later, I promise
if moonsprings_exist then return end

local FRACBITS = FRACBITS
local ANGLE_45 = ANGLE_45
local ANGLE_90 = ANGLE_90
local MAXPLMOVE = 50
local ACCELMAX 		= 6000
local ORIG_FRICTION = 62720
local KART_FULLTURN = 800

-- fuck you
local function N_PogoKartMovement(player, playerMo)
	if not player.pogoSpringJumped then return end
	local playerButtons = player.cmd.buttons

	-- Turncode	
	local playerAngle = playerMo.angle
	-- Don't turn like a fuck, now
	if player.drift ~= 0 then
		playerAngle = playerMo.angle-(ANGLE_45/5)*player.drift
	end
	local thrustAngle = playerAngle

	-- Only apply turnrate if the player has a minimum of speed.
	if player.speed > (20 * mapobjectscale) then
		-- naturally correct this momentum angle to the player's
		local thrustAngle = R_PointToAngle2(0, 0, playerMo.momx, playerMo.momy)
	
		-- turn rate calC
		local angleCorrectRate = FixedDiv((ANGLE_45 + ANG1) - (ANG1 * player.kartweight), mapobjectscale * 35)
	
	
		local angleMovementResult = angleCorrectRate
		local angleSidewaysMovementDiff = thrustAngle - playerAngle
		local angleAbsSidewaysMovement = abs(angleSidewaysMovementDiff)
	
		if angleAbsSidewaysMovement < angleCorrectRate then
			angleMovementResult = angleAbsSidewaysMovement
			-- print("angle less than one, correcting.")
		end
	
		if angleSidewaysMovementDiff > 0 then
			thrustAngle = $ - angleMovementResult
		elseif angleSidewaysMovementDiff < 0 then
			thrustAngle = $ + angleMovementResult
		end
	
		local thrustForce = R_PointToDist2(0, 0, playerMo.momx, playerMo.momy)

		-- let the player control themselves horizontally
		playerMo.momx = FixedMul(thrustForce, cos(thrustAngle))
		playerMo.momy = FixedMul(thrustForce, sin(thrustAngle))
	end

	-- N_PogoKartMovement.
	-- We dont actually need to reimplement K_GetKartSpeed this time, its uncapped :V
	local speedValue = K_GetKartSpeed(player, true, true)
	local accelValue = K_GetKartAccel(player)

	local oldSpeed = R_PointToDist2(0, 0, player.rmomx, player.rmomy) -- FixedMul(P_AproxDistance(player.rmomx, player.rmomy), player.mo.scale);
	if oldSpeed > speedValue then
		oldSpeed = speedValue
	end
	local newSpeed = FixedDiv(FixedDiv(FixedMul(oldSpeed, ACCELMAX - accelValue) +
		FixedMul(speedValue, accelValue), ACCELMAX), ORIG_FRICTION)
		
	-- The boost power provided by K_GetKartSpeed is not enough.... let's amplify that!
	-- Hopefully this shouldn't cause TOO many problems....
	newSpeed = $ + (player.speedboost / 2)
	
	-- just in case...
	player.pogoMinSpeed = $ or 0
	player.pogoMaxSpeed = $ or 0
		
	if player.pogoMinSpeed > 0 then
		local minspeed = player.pogoMinSpeed * mapobjectscale
		if newSpeed < minspeed then
			-- print("too slow!")
			newSpeed = minspeed
		end
	end
	if player.pogoMaxSpeed > 0 then
		local maxspeed = player.pogoMaxSpeed * mapobjectscale
		if newSpeed > maxspeed then
			-- print("too fast!")
			newSpeed = maxspeed
		end
	end

	local finalSpeed = newSpeed - oldSpeed

	-- Yes there is a buff.
	-- The air speed limit is a bitch.
	local forwardmove 	= player.cmd.forwardmove + 25
	local movemul = abs(forwardmove * FRACUNIT) / 50
	
	-- forwardmove is:
	--  50 while accelerating,
	--   0 with no gas, and
	-- -25 when only braking.

	if forwardmove >= 0 then
		finalSpeed = FixedMul(finalSpeed, movemul)
	else
		finalSpeed = FixedMul(-mapobjectscale/2, movemul)
	end
	
-- 	-- NO, WE DO NOT WANT THE AIR SPEED CAP. FUCK YOU.
-- 	local airspeedcap = 50*mapobjectscale
	
-- 	-- reverses
-- 	if airspeed > airspeedcap then
-- 		local mul = 16*FRACUNIT
-- 		local newspeed = 0
		
-- 		newspeed = airspeed + FixedDiv(abs(airspeedcap - airspeed), mul);
		
-- 		player.mo.momx = FixedMul(FixedDiv(player.mo.momx, airspeed), newspeed)
-- 		player.mo.momy = FixedMul(FixedDiv(player.mo.momy, airspeed), newspeed)
-- 	end
	
	-- print(finalSpeed)

	playerMo.momx = $ + P_ReturnThrustX(thrustAngle, finalSpeed)
	playerMo.momy = $ + P_ReturnThrustY(thrustAngle, finalSpeed)

	playerMo.momx = FixedMul(playerMo.momx, playerMo.friction)
	playerMo.momy = FixedMul(playerMo.momy, playerMo.friction)
end

local function K_GetKartDriftSparkValueForStage(player, stage)
	local mul = FRACUNIT

	-- This code is function is pretty much useless now that the timing changes are linear but bleh.
	if stage == 2 then
		mul = 2 * FRACUNIT  -- x2
	elseif stage == 3 then
		mul = 3 * FRACUNIT  -- x3
	elseif stage == 4 then
		mul = 4 * FRACUNIT  -- x4
	end

	return (FixedMul(K_GetKartDriftSparkValue(player) * FRACUNIT, mul) / FRACUNIT)
end

local function K_UpdateSteeringValue(inputSteering, destSteering)
	-- player.steering is the turning value, but with easing applied.
	-- Keeps micro-turning from old easing, but isn't controller dependent.

	local amount = KART_FULLTURN / 3
	local diff = destSteering - inputSteering
	local outputSteering = inputSteering

	-- We switched steering directions, lighten up on easing for a more responsive countersteer.
	-- (Don't do this for steering 0, let digital inputs tap-adjust!)
	if (inputSteering > 0 and destSteering < 0) or (inputSteering < 0 and destSteering > 0) then
		-- Don't let small turns in direction X allow instant turns in direction Y.
		local countersteer = min(KART_FULLTURN, abs(inputSteering))  -- The farthest we should go is to 0 -- neutral.
		amount = max(countersteer, amount)  -- But don't reduce turning strength from baseline either.
	end

	if abs(diff) <= amount then
		-- Reached the intended value, set instantly.
		outputSteering = destSteering
	else
		-- Go linearly towards the value we wanted.
		if diff < 0 then
			outputSteering = outputSteering - amount
		else
			outputSteering = outputSteering + amount
		end
	end

	return outputSteering
end

local function K_MomentumAngleEx(mo, threshold)
	if FixedHypot(mo.momx, mo.momy) > threshold then
		return R_PointToAngle2(0, 0, mo.momx, mo.momy)
	else
		return mo.angle -- default to facing angle, rather than 0
	end
end

local function K_MomentumAngleExAngle(mo, angle, threshold)
	if FixedHypot(mo.momx, mo.momy) > threshold then
		return R_PointToAngle2(0, 0, mo.momx, mo.momy)
	else
		return angle -- default to facing angle, rather than 0
	end
end

local function K_MomentumAngle(mo)
	return K_MomentumAngleEx(mo, 6 * mo.scale)
end

local function N_HandleAirDrift(player)
	if not player.pogoSpringJumped then return end
	
	local minspeed = (10 * player.mo.scale)
	local dsone = K_GetKartDriftSparkValueForStage(player, 1)
	local dstwo = K_GetKartDriftSparkValueForStage(player, 2)
	local dsthree = K_GetKartDriftSparkValueForStage(player, 3)
	local dsfour = K_GetKartDriftSparkValueForStage(player, 4)
	
	player.steering = $ or 0
	player.steering = K_UpdateSteeringValue($, player.cmd.turning)
	
	-- ending drift?
	if player.drift != 5 and player.drift != -5 then
		if player.driftcharge < 0 or player.driftcharge >= dsone then
			-- reverse the momz calculation
			player.mo.momz = $ + (player.lastSpeed/2)
			-- That'll do, for now.
			-- Looking into the forced thrust code is a pain
		end
	end
	
	if player.pflags & PF_DRIFTINPUT and player.drift ~= 0 then
		local driftadditive = 24
		local playsound = false
		
		if player.drift >= 1 then -- left
			player.drift = $ + 1
			if player.drift > 5 then
				player.drift = 5
			end
			if (player.steering > 0) then
				driftadditive = $ + abs(player.steering)/100
			end
			if (player.steering < 0) then
				driftadditive = $ - abs(player.steering)/75
			end
		elseif player.drift <= -1 then -- right
			player.drift = $ - 1
			if player.drift < -5 then
				player.drift = -5
			end
			if (player.steering < 0) then
				driftadditive = $ + abs(player.steering)/100
			end
			if (player.steering > 0) then
				driftadditive = $ - abs(player.steering)/75
			end
		end
		
		-- Disable drift-sparks until you're going fast enough
		if not (player.pflags & PF_GETSPARKS) then
			driftadditive = 0
		end

		-- Inbetween minspeed and minspeed*2, it'll keep your previous drift-spark state.
		if player.speed > minspeed * 2 then
			player.pflags = $ | PF_GETSPARKS

			if player.driftcharge <= -1 then
				player.driftcharge = dsone  -- Back to red
				playsound = true
			end
		elseif player.speed <= minspeed then
			player.pflags = $ & ~PF_GETSPARKS
			driftadditive = 0

			if player.driftcharge >= dsone then
				player.driftcharge = -1  -- Set yellow sparks
				playsound = true
			end
		end
		
		-- makes drifts WAY too fast. dont include this maybe
		if player.driftcharge and driftadditive then
			-- driftadditive = $ + 16
		end
		
		if ((player.driftcharge < dsone and player.driftcharge + driftadditive >= dsone)
			or (player.driftcharge < dstwo and player.driftcharge + driftadditive >= dstwo)
			or (player.driftcharge < dsthree and player.driftcharge + driftadditive >= dsthree))
		then
			playsound = true
		end

		-- Sound whenever you get a different tier of sparks
		if playsound then
			if player.driftcharge == -1 then
				S_StartSoundAtVolume(player.mo, sfx_sploss, 192) -- Yellow spark sound
			else
				S_StartSoundAtVolume(player.mo, sfx_s3ka2, 192)
			end
		end

		player.driftcharge = $ + driftadditive
		player.pflags = $ & ~PF_DRIFTEND
	end
end

local function N_HandleMiscStuff(player)
	if player.pogoSpringJumped and not P_IsObjectOnGround(player.mo) then
		player.drawangle = (ANGLE_22h * leveltime) -- increment turn sprite
		if not ((player.mo.eflags & MFE_SPRUNG) or (player.mo.eflags & MFE_UNDERWATER))then -- additional gravity
			player.mo.momz = $ + (5 * P_GetMobjGravity(player.mo)) / 2
		end
	end
end

addHook("PlayerThink", function(player)
	if not player.mo then return end
	
	player.pogoSpringJumped = $ or 0
	N_HandleMiscStuff(player)
	N_PogoKartMovement(player, player.mo)
	N_HandleAirDrift(player)
end)

addHook("MobjThinker", function(mo)
	if not mo.player then return end
	local player = mo.player
	player.lastSpeed = player.speed
	-- print(player.lastSpeed/FRACUNIT)
end, MT_PLAYER)

addHook("PostThinkFrame", function()
	for player in players.iterate do
		if not player.mo then continue end
		player.pogoSpringJumped = $ or 0
		if P_IsObjectOnGround(player.mo) then
			player.pogoSpringJumped = max(0, $ - 1)
		end
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate do
		if not player.mo then continue end
		player.lastDrift = player.drift
		player.lastSpeed = player.speed
	end
end)

-- addHook("PreThinkFrame", function()
-- 	for player in players.iterate do
-- 		if not player.mo then continue end
-- 		player.prevDriftCharge = player.driftcharge
-- 	end
-- end)

rawset(_G, "N_DoLegacyV1Spring", function(mo, vertispeed, sound, scale)
	local vscale = (mapobjectscale*scale)
	if mo.player and mo.player.spectator then return end
	if mo.eflags & MFE_SPRUNG then return end

	-- broing
	mo.eflags = $ | MFE_SPRUNG
	vertispeed = $ * P_MobjFlip(mo)
	
	-- fastfall funni
	if mo.player then
		mo.player.fastfall = 0
	end
	
	-- default spring thrust behavior
	if vertispeed == 0 then
		-- todo: broken
		local thrust = P_AproxDistance(mo.momx, mo.momy)
		mo.momz = P_MobjFlip(mo) * FixedMul(FixedMul(thrust, vscale), sin(ANGLE_22h))
	else
		if mo.player and mo.player.pogoSpringJumped and mo.player.pogoMaxSpeed == 0 then -- pogo is not springcapped
			if mo.player.sneakertimer then
				vertispeed = FixedMul(vertispeed, 5*FRACUNIT/4)
			elseif mo.player.invincibilitytimer then
				vertispeed = FixedMul(vertispeed, 9*FRACUNIT/8)
			end
		end
		mo.momz = P_MobjFlip(mo) * FixedMul(vertispeed, vscale)
	end
	
	if mo.eflags & MFE_UNDERWATER then
		mo.momz = (117 * mo.momz) / 200
	end
	
	if sound then
		S_StartSound(mo, (sound == 1 and sfx_kc2f or sfx_kpogos))
	end
end)

local function __Execute_Spring(mo, args)
	if not P_IsObjectOnGround(mo) then return end
	
	-- arguments!
	local minSpeed, maxSpeed, scaleVal, color = args[1], args[2], args[3], args[4]
	scaleVal = $ or 1
	-- default to red, idiot
	color = $ or SKINCOLOR_RASPBERRY
	
	-- player!
	local player = mo.player
	
	-- apply pogo stuff hererer
	if player then
		player.pogoSpringJumped = 2
		player.pogoMinSpeed = args[1]
		player.pogoMaxSpeed = args[2]
	end
	-- default is.... 48!
	N_DoLegacyV1Spring(mo, 48*FRACUNIT, 1, scaleVal)
	-- print(mo.momz)
	
	-- speed cap
	if player then
		local finalAngle = (FixedHypot(mo.momx, mo.momy) and R_PointToAngle2(0, 0, mo.momx, mo.momy) or mo.angle)
		-- In Kart code, this is BEFORE the DoPogoSpring call, but this should be fine... Execute the speedcap!
		if (minSpeed ~= 0 and player.speed < minSpeed*mapobjectscale) then
			P_InstaThrust(mo, finalAngle, minSpeed*mapobjectscale)
		end
		if (maxSpeed ~= 0 and player.speed > maxSpeed*mapobjectscale) then
			P_InstaThrust(mo, finalAngle, maxSpeed*mapobjectscale)
		end
		
		player.springstars = max(abs(mo.momz), 0) / FRACUNIT / 2
		player.springcolor = color
		
		-- give them atleast a fair bit
		P_Thrust(mo, finalAngle, (minSpeed*mapobjectscale)/5)
	end
end

-- From ACS.
addHook("SpecialExecute", function(activator, args)
	if not activator.mo then return end
	__Execute_Spring(activator.mo, args)
end, "POGOSPRING")

local MSF_FLIPSPECIAL_FLOOR = 1
local MSF_FLIPSPECIAL_CEILING = 1<<1
local MSF_TRIGGERSPECIAL_TOUCH = 1<<2
local SSF_MOONPANELRED = 1<<9
local SSF_MOONPANELYEL = 1<<10

local USE_AUTOMATIC = false
local lastgamemap = -1

-- AUTOMATIC. EXTREMELY EXPERIMENTAL.
-- kk please gib access to mobj terrain defintion soon :pray:
addHook("MapLoad", function()
	USE_AUTOMATIC = false
	for sec in sectors.iterate do
		// 2080 and 2081 is a sector action we can use
		if not (sec.floorpic == "MPNLR1" or sec.floorpic == "MPNLR2" or sec.floorpic == "MPNLY1" or sec.floorpic == "MPNLY2" or sec.action == 2080 or sec.action == 2081) then continue end
		if sec.action == 475 then continue end -- assume its already set by mapper
		
		-- Yes, we need this.
		sec.flags = $ | MSF_TRIGGERSPECIAL_TOUCH
		-- Add a funny dummy flag for this shit to trigger as well
		if (sec.floorpic == "MPNLR1" or sec.floorpic == "MPNLR2") or sec.action == 2080 then
			-- print("Unmarked red moon panel found!")
			sec.specialflags = $ | SSF_MOONPANELRED
		elseif (sec.floorpic == "MPNLY1" or sec.floorpic == "MPNLY2") or sec.action == 2081 then
			-- print("Unmarked yellow moon panel found!")
			sec.specialflags = $ | SSF_MOONPANELYEL
		end
		
		USE_AUTOMATIC = true
	end
	
	if USE_AUTOMATIC and lastgamemap ~= gamemap then
		CONS_Printf(consoleplayer, "\x83".."NOTICE: ".."\x80".."Unmarked moon panels found! May result in performance drops.")
		lastgamemap = gamemap
	end
end)

addHook("NetVars", function(net) USE_AUTOMATIC = net($) end)

addHook("PlayerThink", function(player)
	if not USE_AUTOMATIC then return end
	if not player.mo then return end
	
	local mo = player.mo
	if not P_IsObjectOnGround(mo) then return end
	
	local sec = P_MobjTouchingSectorSpecialFlag(mo, SSF_MOONPANELRED) or P_MobjTouchingSectorSpecialFlag(mo, SSF_MOONPANELYEL)
	
	if not sec then return end
	
	if sec == mo.subsector.sector then
		-- We can leave fofs be here, since those have their own checks
		-- But we need to check if we're actually touching the damn sector here, and account for slopes as well
		local flr = P_MobjFloorZ(mo, sec, sec, mo.x, mo.y, nil, false, true)
		local cel = P_MobjCeilingZ(mo, sec, sec, mo.x, mo.y, nil, true, true) -- get Z coords of both floors and ceilings for this sector (this accounts for slopes properly.)
		-- NOTE: we don't use P_GetZAt with our x/y directly because the mobj won't have the same height because of its hitbox on the slope. Complex garbage but tldr it doesn't work.

		if not (((sec.flags & MSF_FLIPSPECIAL_FLOOR) ~= 0 and mo.z == flr)  -- floor check
		   or ((mo.eflags & MFE_VERTICALFLIP) ~= 0 and (sec.flags & MSF_FLIPSPECIAL_CEILING) ~= 0 and (mo.z + mo.height) == cel)) then  -- ceiling check
			return
		end
	end
	
	if sec.specialflags & SSF_MOONPANELRED then -- red
		__Execute_Spring(mo, {24, 0, 1, SKINCOLOR_RASPBERRY})
		-- print("Unmarked red moon panel activated!")
	else -- yellow
		__Execute_Spring(mo, {24, 28, 1, SKINCOLOR_YELLOW})
		-- print("Unmarked yellow moon panel activated!")
	end
end)

addHook("MobjMoveBlocked", function(mobj, thing, line)
	if not (mobj and mobj.player) then return end
	local player = mobj.player
	if line and line.valid then
		if line.flags & ML_NOTBOUNCY then return end
		if player.pogoSpringJumped then
			-- print("bonked a wall, idiot!")
			player.pogoSpringJumped = 0
		end
	end
end, MT_PLAYER)

rawset(_G, "moonsprings_exist", true)
